package com.zksy.framework.web.service;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zksy.common.core.domain.entity.SysDept;
import com.zksy.common.core.domain.entity.SysUser;
import com.zksy.common.core.domain.model.LoginUser;
import com.zksy.common.enums.UserStatus;
import com.zksy.common.exception.ServiceException;
import com.zksy.common.utils.StringUtils;
import com.zksy.system.service.ISysDeptService;
import com.zksy.system.service.ISysUserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

/**
 * 用户验证处理
 *
 * @author ruoyi
 */
@Service
public class UserDetailsServiceImpl implements UserDetailsService {
    private static final Logger log = LoggerFactory.getLogger(UserDetailsServiceImpl.class);

    @Autowired
    private ISysUserService userService;

    @Autowired
    private SysPermissionService permissionService;

    @Autowired
    private ISysDeptService sysDeptService;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        SysUser user = userService.selectUserByUserName(username);
        if (StringUtils.isNull(user)) {
            log.info("登录用户：{} 不存在.", username);
            throw new ServiceException("登录用户：" + username + " 不存在");
        } else if (UserStatus.DELETED.getCode().equals(user.getDelFlag())) {
            log.info("登录用户：{} 已被删除.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已被删除");
        } else if (UserStatus.DISABLE.getCode().equals(user.getStatus())) {
            log.info("登录用户：{} 已被停用.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已停用");
        }
        Long deptId = user.getDeptId();
        BaseMapper<SysDept> baseMapper = sysDeptService.getBaseMapper();
        SysDept dept = baseMapper.selectById(deptId);
        if (StringUtils.isNull(dept)) {
            log.info("登录用户：{} 所属机构不存在.", username);
            throw new ServiceException("登录用户：" + username + "所属机构不存在");
        } else {
            if (!"0".equals(dept.getStatus())) {
                log.info("登录用户：{} .所属机构被禁用", username);
                throw new ServiceException("登录用户：【" + username + "】所属机构被禁用");
            } else if (!"0".equals(dept.getDelFlag())) {
                log.info("登录用户：{} .所属机构被删除", username);
                throw new ServiceException("登录用户：【" + username + "】所属机构被删除");
            }
        }
        return createLoginUser(user);
    }

    public UserDetails createLoginUser(SysUser user) {
        return new LoginUser(user.getUserId(), user.getDeptId(), user, permissionService.getMenuPermission(user));
    }
}
